<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_previous_practice".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPreviousPractice".
 *
 * Columns in table "provider_previous_practice" available as properties of the model,
 * followed by relations of table "provider_previous_practice" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $account_id
 * @property string $practice_name
 * @property integer $practice_group_id
 * @property string $address
 * @property string $address_2
 * @property integer $location_id
 * @property double $latitude
 * @property double $longitude
 * @property string $phone_number
 * @property string $fax_number
 * @property string $email
 * @property string $website
 * @property integer $handicap_accesible
 * @property integer $aesthetic_procedure
 * @property string $description
 * @property string $logo_path
 * @property string $date_added
 * @property string $date_deleted
 * @property string $phone_number_clean
 * @property integer $out_of_network
 * @property integer $facility_fee
 * @property string $npi_id
 * @property string $yext_location_id
 * @property string $dme_services
 *
 * @property Location $location
 * @property Account $account
 */
abstract class BaseProviderPreviousPractice extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_previous_practice';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPreviousPractice|ProviderPreviousPractices', $n);
    }

    public static function representingColumn()
    {
        return 'practice_name';
    }

    public function rules()
    {
        return array(
            array('provider_id, account_id, practice_name', 'required'),
            array('provider_id, account_id, practice_group_id, location_id, handicap_accesible, aesthetic_procedure, '
                . 'out_of_network, facility_fee', 'numerical', 'integerOnly' => true),
            array('latitude, longitude', 'numerical'),
            array('practice_name', 'length', 'max' => 150),
            array('address, address_2', 'length', 'max' => 80),
            array('phone_number, fax_number, phone_number_clean', 'length', 'max' => 14),
            array('email', 'length', 'max' => 254),
            array('website, logo_path', 'length', 'max' => 255),
            array('npi_id', 'length', 'max' => 10),
            array('yext_location_id', 'length', 'max' => 20),
            array('dme_services', 'length', 'max' => 100),
            array('description, date_added, date_deleted', 'safe'),
            array('practice_group_id, address, address_2, location_id, latitude, longitude, phone_number, '
                . 'fax_number, email, website, handicap_accesible, aesthetic_procedure, description, logo_path, '
                . 'date_added, date_deleted, phone_number_clean, out_of_network, facility_fee, npi_id, '
                . 'yext_location_id, dme_services', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, account_id, practice_name, practice_group_id, address, address_2, location_id, '
                . 'latitude, longitude, phone_number, fax_number, email, website, handicap_accesible, '
                . 'aesthetic_procedure, description, logo_path, date_added, date_deleted, phone_number_clean, '
                . 'out_of_network, facility_fee, npi_id, yext_location_id, dme_services', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'location' => array(self::BELONGS_TO, 'Location', 'location_id'),
            'account' => array(self::BELONGS_TO, 'Account', 'account_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'account_id' => Yii::t('app', 'Account'),
            'practice_name' => Yii::t('app', 'Practice'),
            'practice_group_id' => Yii::t('app', 'Practice Group'),
            'address' => Yii::t('app', 'Address'),
            'address_2' => Yii::t('app', 'Address 2'),
            'location_id' => null,
            'latitude' => Yii::t('app', 'Latitude'),
            'longitude' => Yii::t('app', 'Longitude'),
            'phone_number' => Yii::t('app', 'Phone Number'),
            'fax_number' => Yii::t('app', 'Fax Number'),
            'email' => Yii::t('app', 'Email'),
            'website' => Yii::t('app', 'Website'),
            'handicap_accesible' => Yii::t('app', 'Handicap Accesible'),
            'aesthetic_procedure' => Yii::t('app', 'Aesthetic Procedures Complete'),
            'description' => Yii::t('app', 'Description'),
            'logo_path' => Yii::t('app', 'Logo Path'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_deleted' => Yii::t('app', 'Date Deleted'),
            'phone_number_clean' => Yii::t('app', 'Phone Number Clean'),
            'out_of_network' => Yii::t('app', 'Out Of Network'),
            'facility_fee' => Yii::t('app', 'Facility Fee'),
            'npi_id' => Yii::t('app', 'Npi'),
            'yext_location_id' => Yii::t('app', 'Yext Location'),
            'dme_services' => Yii::t('app', 'Dme Services'),
            'location' => null,
            'account' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('account_id', $this->account_id);
        $criteria->compare('practice_name', $this->practice_name, true);
        $criteria->compare('practice_group_id', $this->practice_group_id);
        $criteria->compare('address', $this->address, true);
        $criteria->compare('address_2', $this->address_2, true);
        $criteria->compare('location_id', $this->location_id);
        $criteria->compare('latitude', $this->latitude);
        $criteria->compare('longitude', $this->longitude);
        $criteria->compare('phone_number', $this->phone_number, true);
        $criteria->compare('fax_number', $this->fax_number, true);
        $criteria->compare('email', $this->email, true);
        $criteria->compare('website', $this->website, true);
        $criteria->compare('handicap_accesible', $this->handicap_accesible);
        $criteria->compare('aesthetic_procedure', $this->aesthetic_procedure);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('logo_path', $this->logo_path, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_deleted', $this->date_deleted, true);
        $criteria->compare('phone_number_clean', $this->phone_number_clean, true);
        $criteria->compare('out_of_network', $this->out_of_network);
        $criteria->compare('facility_fee', $this->facility_fee);
        $criteria->compare('npi_id', $this->npi_id, true);
        $criteria->compare('yext_location_id', $this->yext_location_id, true);
        $criteria->compare('dme_services', $this->dme_services, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
